// #autoload
// #name = Nash_ChainZoom
// #version = 1.0
// #date = 26 Feb 2003
// #author = -Na$hMan-
// #warrior = -Na$hMan-
// #email = the_real_nashman@hotmail.com
// #category = Nash's Scripts
// #description = Ability to change the Fov and the Sensitiviy while chaining.
// #status = Release
// #config = NashChainZoomGUI

if(!isObject(NashChainZoom))
{
	new ScriptObject(NashChainZoom)
	{
	        class = NashChainZoom;
                version = "1.0";
	};
}

if(isFile("prefs/NashPrefs.cs") && !$NashPref::loaded)
{
	exec("prefs/NashPrefs.cs");
	$NashPref::loaded = true;
}
else if(!$NashPref::loaded)
{
	$NashPref::ChainZoom::ChainFoV = 90;
        $NashPref::ChainZoom::DefaultFoV = $pref::Player::defaultFoV;
        $NashPref::ChainZoom::SensFactor = "50";
        $NashPref::ChainZoom::HideRet = 1;
        $NashPref::ChainZoom::HideDelay = 1500;
        $NashPref::ChainZoom::Enabled = true;
        $NashPref::ChainZoom::Version = NashChainZoom.Version;
        $NashPref::loaded = true;
}

package NashChainZoomPackage
{
	function mouseFire(%val)
	{
		parent::mouseFire(%val);
		if(!$ZoomOn && $NashPref::ChainZoom::Enabled)
		{
			if(%val && $NashChainZoom::EnableZoom)
			{
				if($NashPref::ChainZoom::HideRet) reticleHud.schedule($NashPref::ChainZoom::HideDelay,setVisible,false);
				setFoV($NashPref::ChainZoom::chainFoV);
				ChainZoomSense(1);
			}
			else
			{
				reticleHud.setVisible(true);
				setFoV($NashPref::ChainZoom::defaultFoV);
				ChainZoomSense(0);
			}
		}
	}
	function clientCmdSetWeaponsHudActive(%slot, %ret, %vis)
    	{
		parent::clientCmdSetWeaponsHudActive(%slot, %ret, %vis);
		
		%CurrentWeapon = $WeaponNames[%slot];
		reticleHud.setVisible(true);
		switch$(%CurrentWeapon)
		{
			case "chaingun":
				$NashChainZoom::EnableZoom = true;
			default:
				$NashChainZoom::EnableZoom = false;
		}
	}
        function ClientCmdDisplayHuds()
	{
		parent::ClientCmdDisplayHuds();
                schedule(150, 0, setFoV, $pref::player::defaultFoV);
		schedule(1000, 0, setFoV, $pref::player::defaultFoV);
    	}
        function OptionsDlg::onWake(%this)
	{
		if(!NashChainZoom.bind)
		{
			$RemapName[$RemapCount] = "ChainZoom Toggle";
			$RemapCmd[$RemapCount] = "ChainZoomToggle";
			$RemapCount++;
                        NashChainZoom.bind = true;
		}
                parent::onWake(%this);
	}
	function quit()
	{
		if(!$NashPrefsSaved)
		{
			export("$NashPref::*", "prefs/NashPrefs.cs", false);			
			$NashPrefsSaved = true;
		}
		parent::quit();
	}
	function clientCmdSetPassengerVehicleKeys()
	{
		rebindAction(passengerKeys, moveMap, ChainZoomSense, false, ChainZoomVehicleSense);
		parent::clientCmdSetPassengerVehicleKeys();
	}	
	
};
activatePackage(NashChainZoomPackage);

function ChainZoomToggle(%val)
{
        if(!%val)
        return;

        $NashPref::ChainZoom::Enabled = !$NashPref::ChainZoom::Enabled;

        alxPlay(sButtonOver, 0, 0, 0);

        if($NashPref::ChainZoom::Enabled)
	        addMessageHudLine("\c2ChainZoom enabled.");
        else
	        addMessageHudLine("\c2ChainZoom disabled.");
}
function NashChainZoomMouseMap(%fromMap)
{
	if(isObject(%fromMap))
	{
		if(isObject(NashChainMap))
		{
			NashChainMap.pop();
			NashChainMap.delete();
		}
		new ActionMap(NashChainMap);
		%currentYaw = %fromMap.getScale(mouse, xaxis);
		%currentPitch = %fromMap.getScale(mouse, yaxis);
		%mouseInverted = %fromMap.isInverted(mouse, yaxis);
		%yFlags = %mouseInverted ? "SI" : "S";
		NashChainMap.bind(mouse, xaxis, "S", $NashPref::ChainZoom::SensFactor / 100 * %currentYaw, "yaw");
		NashChainMap.bind(mouse, yaxis, %yFlags, $NashPref::ChainZoom::SensFactor / 100 * %currentPitch, "pitch");
		NashChainMap.push();
	}
	else
	{
		if(isObject(NashChainMap))
		{
			NashChainMap.pop();
			NashChainMap.delete();
		}
	}
}
function ChainZoomSense(%val)
{
	NashChainZoomMouseMap(%val ? moveMap : 0);
}
function ChainZoomVehicleSense(%val)
{
	NashChainZoomMouseMap(%val ? passengerKeys : 0);
}
function NashChainZoomGUI::onWake(%this)
{
	NashChainSenseSlider.setValue($NashPref::ChainZoom::SensFactor);
	NashChainZoomSlider.setValue($NashPref::ChainZoom::ChainFoV);
	NashChainHideRet.setValue($NashPref::ChainZoom::HideRet);
	NashChainHideDelay.setValue($NashPref::ChainZoom::HideDelay);
}
function NashChainZoom::updateSensInterval(%this)
{
	$NashPref::ChainZoom::SensFactor = mfloor(NashChainSenseSlider.getValue());
	NashChainSensConfigText.setValue(mfloor(NashChainSenseSlider.getValue()) @ "%");
}
function NashChainZoom::updateZoomInterval(%this)
{
	$NashPref::ChainZoom::ChainFoV = mfloor(NashChainZoomSlider.getValue());
	NashChainZoomConfigText.setValue(mfloor(NashChainZoomSlider.getValue()) @ "");
}
if(!isObject(NashChainZoomGUI))
{
	new GuiControl(NashChainZoomGUI) 
        {
	        profile = "GuiDefaultProfile";
	        horizSizing = "center";
	        vertSizing = "center";
	        position = "15 26";
	        extent = "370 135";
	        minExtent = "370 135";
	        visible = "1";
	        hideCursor = "0";
	        bypassHideCursor = "0";
	        helpTag = "0";

	        new ShellPaneCtrl() 
                {
		        profile = "ShellDlgPaneProfile";
		        horizSizing = "center";
	                vertSizing = "center";
			position = "1 83";
			extent = "368 133";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Nash_ChainZoom";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";

			new ShellSliderCtrl(NashChainZoomSlider) 
                        {
				profile = "ShellSliderProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "87 57";
				extent = "221 24";
				minExtent = "12 24";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "value";
				altCommand = "NashChainZoom.updateZoomInterval();";
				helpTag = "0";
				range = "50.000000 120.000000";
				ticks = "10";
				value = "90";
				usePlusMinus = "1";
			};
                        new ShellSliderCtrl(NashChainSenseSlider) 
                        {
			        profile = "ShellSliderProfile";
			        horizSizing = "right";
			        vertSizing = "bottom";
			        position = "87 35";
			        extent = "221 24";
			        minExtent = "12 24";
			        visible = "1"; 
			        hideCursor = "0";
			        bypassHideCursor = "0"; 
  			        variable = "value";
			        altCommand = "NashChainZoom.updateSensInterval();";
			        helpTag = "0";
			        range = "0.000000 100.000000";
			        ticks = "10";
			        value = "50";
			        usePlusMinus = "1";
			};
			new ShellToggleButton(NashChainHideRet) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "17 88";
				extent = "125 27";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$NashPref::ChainZoom::HideRet";
				helpTag = "0";
				text = "Hide Chain Ret";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new ShellTextEditCtrl(NashChainHideDelay) {
				profile = "NewTextEditProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "147 83";
				extent = "73 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$NashPref::ChainZoom::HideDelay";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
				historySize = "0";
				password = "0";
				IRCName = "0";
				tabComplete = "0";
				glowOffset = "9 9";
			};
			new ShellBitmapButton() 
                        {
				profile = "ShellButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "217 83";
				extent = "140 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				command = "Canvas.pushDialog(MouseConfigDlg);";
				helpTag = "0";
				text = "CONFIGURE MOUSE";
				simpleStyle = "0";
			};
			new GuiTextCtrl(NashChainSensConfigText) 
                        {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "322 39";
				extent = "24 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl(NashChainZoomConfigText)
                        {
				profile = "ShellTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "322 61";
				extent = "21 22";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl() 
	                {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "22 40";
				extent = "57 17";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Sensitivity :";
				longTextBuffer = "0";
				maxLength = "255";
			};
			new GuiTextCtrl() 
                        {
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "22 63";
				extent = "60 15";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "Chain FoV :";
				longTextBuffer = "0";
				maxLength = "255";
			};
//			new GuiTextCtrl() 
//	                {
//				profile = "GuiDefaultProfile";
//				horizSizing = "right";
//				vertSizing = "bottom";
//				position = "23 102";
//				extent = "148 17";
//				minExtent = "8 8";
//				visible = "1";
//				hideCursor = "0";
//				bypassHideCursor = "0";
//				helpTag = "0";
//				text = "(Sensitivity : 100% = Normal)";
//				longTextBuffer = "0";
//				maxLength = "255";
//			};
		};
	};
}